# openrqm
This is the OpenRQM API specification.
[OpenRQM Docs - Github](https://github.com/openrqm/openrqm-docs)


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.24
- Build package: org.openapitools.codegen.languages.DartClientCodegen

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  openrqm:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  openrqm:
    path: /path/to/openrqm
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:openrqm/api.dart';

// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroup = RQMAccessGroup(); // RQMAccessGroup | The access group to create

try {
    api_instance.addAccessgroup(accessGroup);
} catch (e) {
    print("Exception when calling AccessGroupsApi->addAccessgroup: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccessGroupsApi* | [**addAccessgroup**](doc\/AccessGroupsApi.md#addaccessgroup) | **POST** /accessgroup | Add an access group
*AccessGroupsApi* | [**addUserToAccessGroup**](doc\/AccessGroupsApi.md#addusertoaccessgroup) | **POST** /accessgroup/users | Add a user to an access group
*AccessGroupsApi* | [**deleteAccessgroup**](doc\/AccessGroupsApi.md#deleteaccessgroup) | **DELETE** /accessgroup | Delete an access group
*AccessGroupsApi* | [**deleteUserOfAccessGroup**](doc\/AccessGroupsApi.md#deleteuserofaccessgroup) | **DELETE** /accessgroup/users | Delete a user of an access group
*AccessGroupsApi* | [**getAccessgroup**](doc\/AccessGroupsApi.md#getaccessgroup) | **GET** /accessgroup | Get a specific access group
*AccessGroupsApi* | [**getAccessgroups**](doc\/AccessGroupsApi.md#getaccessgroups) | **GET** /accessgroups | Get all access groups
*AccessGroupsApi* | [**getUsersOfAccessGroup**](doc\/AccessGroupsApi.md#getusersofaccessgroup) | **GET** /accessgroup/users | Get all users of a given access group
*AccessGroupsApi* | [**patchAccessgroup**](doc\/AccessGroupsApi.md#patchaccessgroup) | **PATCH** /accessgroup | Update an access group
*DocumentsApi* | [**deleteDocument**](doc\/DocumentsApi.md#deletedocument) | **DELETE** /document | Delete a document
*DocumentsApi* | [**getDocument**](doc\/DocumentsApi.md#getdocument) | **GET** /document | Get a document
*DocumentsApi* | [**getDocuments**](doc\/DocumentsApi.md#getdocuments) | **GET** /documents | Get all documents
*DocumentsApi* | [**getLinksOfDocument**](doc\/DocumentsApi.md#getlinksofdocument) | **GET** /document/links | Get all links of a document
*DocumentsApi* | [**patchDocument**](doc\/DocumentsApi.md#patchdocument) | **PATCH** /document | Update a document
*DocumentsApi* | [**postDocument**](doc\/DocumentsApi.md#postdocument) | **POST** /document | Add a document
*ElementsApi* | [**deleteElement**](doc\/ElementsApi.md#deleteelement) | **DELETE** /element | Delete an element
*ElementsApi* | [**getElementTypes**](doc\/ElementsApi.md#getelementtypes) | **GET** /elementTypes | Get all element types
*ElementsApi* | [**getElements**](doc\/ElementsApi.md#getelements) | **GET** /elements | Get all elements
*ElementsApi* | [**getIncomingLinksOfElement**](doc\/ElementsApi.md#getincominglinksofelement) | **GET** /element/inlinks | Get all links of a given element
*ElementsApi* | [**getOutgoingLinksOfElement**](doc\/ElementsApi.md#getoutgoinglinksofelement) | **GET** /element/outlinks | Get all links of a given element
*ElementsApi* | [**patchElement**](doc\/ElementsApi.md#patchelement) | **PATCH** /element | Update an element
*ElementsApi* | [**postElement**](doc\/ElementsApi.md#postelement) | **POST** /element | Add an element
*ExportApi* | [**exportMarkdown**](doc\/ExportApi.md#exportmarkdown) | **GET** /export/markdown | Export a document as Markdown
*ExportApi* | [**exportPdf**](doc\/ExportApi.md#exportpdf) | **GET** /export/pdf | Export a document as PDF
*ExportApi* | [**exportRaw**](doc\/ExportApi.md#exportraw) | **GET** /export/openrqm | Export a document as OpenRQM Data for import
*ExportApi* | [**getMarkdownTemplates**](doc\/ExportApi.md#getmarkdowntemplates) | **GET** /export/markdown/templates | Get all Markdown templates
*ExportApi* | [**getPdfTemplates**](doc\/ExportApi.md#getpdftemplates) | **GET** /export/pdf/templates | Get all PDF templates
*ImportApi* | [**importDocument**](doc\/ImportApi.md#importdocument) | **POST** /import | Post document for import
*LinksApi* | [**deleteLink**](doc\/LinksApi.md#deletelink) | **DELETE** /link | Delete a link
*LinksApi* | [**getLinkTypes**](doc\/LinksApi.md#getlinktypes) | **GET** /linkTypes | Get the link types
*LinksApi* | [**linkElement**](doc\/LinksApi.md#linkelement) | **POST** /link | Link two elements
*ThemesApi* | [**createTheme**](doc\/ThemesApi.md#createtheme) | **POST** /theme | Create a new theme
*ThemesApi* | [**getElementTypeColorsOfTheme**](doc\/ThemesApi.md#getelementtypecolorsoftheme) | **GET** /theme/elementTypeColors | Get all element type colors of a theme
*ThemesApi* | [**getTheme**](doc\/ThemesApi.md#gettheme) | **GET** /theme | Get a theme
*ThemesApi* | [**getThemesOfDocument**](doc\/ThemesApi.md#getthemesofdocument) | **GET** /document/themes | Get all themes of a document
*ThemesApi* | [**updateTheme**](doc\/ThemesApi.md#updatetheme) | **PATCH** /theme | Update a theme
*UserManagementApi* | [**changeUser**](doc\/UserManagementApi.md#changeuser) | **PATCH** /user/change | Change user
*UserManagementApi* | [**deleteUser**](doc\/UserManagementApi.md#deleteuser) | **DELETE** /user/delete | Delete user
*UserManagementApi* | [**getInfo**](doc\/UserManagementApi.md#getinfo) | **GET** /user/info | Get info of user
*UserManagementApi* | [**getUsers**](doc\/UserManagementApi.md#getusers) | **GET** /user | Get all users
*UserManagementApi* | [**login**](doc\/UserManagementApi.md#login) | **GET** /user/login | Login
*UserManagementApi* | [**logout**](doc\/UserManagementApi.md#logout) | **GET** /user/logout | Logout
*UserManagementApi* | [**register**](doc\/UserManagementApi.md#register) | **POST** /user/register | Register
*WorkspacesApi* | [**addAccessGroupToWorkspace**](doc\/WorkspacesApi.md#addaccessgrouptoworkspace) | **POST** /workspace/accessgroups | Add an access group to a workspace
*WorkspacesApi* | [**addUserToWorkspace**](doc\/WorkspacesApi.md#addusertoworkspace) | **POST** /workspace/users | Add a user to a workspace
*WorkspacesApi* | [**deleteAccessGroupOfWorkspace**](doc\/WorkspacesApi.md#deleteaccessgroupofworkspace) | **DELETE** /workspace/accessgroups | Delete a workspace
*WorkspacesApi* | [**deleteUserOfWorkspace**](doc\/WorkspacesApi.md#deleteuserofworkspace) | **DELETE** /workspace/users | Delete a user of a workspace
*WorkspacesApi* | [**deleteWorkspace**](doc\/WorkspacesApi.md#deleteworkspace) | **DELETE** /workspace | Delete a workspace
*WorkspacesApi* | [**getAccessGroupsOfWorkspace**](doc\/WorkspacesApi.md#getaccessgroupsofworkspace) | **GET** /workspace/accessgroups | Get all access groups of a given workspace
*WorkspacesApi* | [**getUsersOfWorkspace**](doc\/WorkspacesApi.md#getusersofworkspace) | **GET** /workspace/users | Get all users of a given workspace
*WorkspacesApi* | [**getWorkspace**](doc\/WorkspacesApi.md#getworkspace) | **GET** /workspace | Get a workspace
*WorkspacesApi* | [**getWorkspaces**](doc\/WorkspacesApi.md#getworkspaces) | **GET** /workspaces | Get all workspaces
*WorkspacesApi* | [**patchAccessGroupOfWorkspace**](doc\/WorkspacesApi.md#patchaccessgroupofworkspace) | **PATCH** /workspace/accessgroups | Update an access group of a workspace
*WorkspacesApi* | [**patchUserOfWorkspace**](doc\/WorkspacesApi.md#patchuserofworkspace) | **PATCH** /workspace/users | Update a user of a workspace
*WorkspacesApi* | [**patchWorkspace**](doc\/WorkspacesApi.md#patchworkspace) | **PATCH** /workspace | Update a workspace
*WorkspacesApi* | [**postWorkspace**](doc\/WorkspacesApi.md#postworkspace) | **POST** /workspace | Add a workspace


## Documentation For Models

 - [RQMAccessGroup](doc\/RQMAccessGroup.md)
 - [RQMDocument](doc\/RQMDocument.md)
 - [RQMElement](doc\/RQMElement.md)
 - [RQMElementType](doc\/RQMElementType.md)
 - [RQMElementTypeColor](doc\/RQMElementTypeColor.md)
 - [RQMLink](doc\/RQMLink.md)
 - [RQMLinkType](doc\/RQMLinkType.md)
 - [RQMTemplate](doc\/RQMTemplate.md)
 - [RQMTheme](doc\/RQMTheme.md)
 - [RQMToken](doc\/RQMToken.md)
 - [RQMUser](doc\/RQMUser.md)
 - [RQMWorkspace](doc\/RQMWorkspace.md)
 - [RQMWorkspaceAccessgroup](doc\/RQMWorkspaceAccessgroup.md)
 - [RQMWorkspaceUser](doc\/RQMWorkspaceUser.md)


## Documentation For Authorization


## APIKeyHeader

- **Type**: API key
- **API key parameter name**: token
- **Location**: HTTP header


## Author




