# openrqm.api.AccessGroupsApi

## Load the API package
```dart
import 'package:openrqm/api.dart';
```

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Method | HTTP request | Description
------------- | ------------- | -------------
[**addAccessgroup**](AccessGroupsApi.md#addAccessgroup) | **POST** /accessgroup | Add an access group
[**addUserToAccessGroup**](AccessGroupsApi.md#addUserToAccessGroup) | **POST** /accessgroup/users | Add a user to an access group
[**deleteAccessgroup**](AccessGroupsApi.md#deleteAccessgroup) | **DELETE** /accessgroup | Delete an access group
[**deleteUserOfAccessGroup**](AccessGroupsApi.md#deleteUserOfAccessGroup) | **DELETE** /accessgroup/users | Delete a user of an access group
[**getAccessgroup**](AccessGroupsApi.md#getAccessgroup) | **GET** /accessgroup | Get a specific access group
[**getAccessgroups**](AccessGroupsApi.md#getAccessgroups) | **GET** /accessgroups | Get all access groups
[**getUsersOfAccessGroup**](AccessGroupsApi.md#getUsersOfAccessGroup) | **GET** /accessgroup/users | Get all users of a given access group
[**patchAccessgroup**](AccessGroupsApi.md#patchAccessgroup) | **PATCH** /accessgroup | Update an access group


# **addAccessgroup**
> addAccessgroup(accessGroup)

Add an access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroup = RQMAccessGroup(); // RQMAccessGroup | The access group to create

try { 
    api_instance.addAccessgroup(accessGroup);
} catch (e) {
    print("Exception when calling AccessGroupsApi->addAccessgroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroup** | [**RQMAccessGroup**](RQMAccessGroup.md)| The access group to create | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **addUserToAccessGroup**
> addUserToAccessGroup(accessGroupId, userId)

Add a user to an access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroupId = 789; // int | 
var userId = 789; // int | 

try { 
    api_instance.addUserToAccessGroup(accessGroupId, userId);
} catch (e) {
    print("Exception when calling AccessGroupsApi->addUserToAccessGroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroupId** | **int**|  | [default to null]
 **userId** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteAccessgroup**
> deleteAccessgroup(accessGroupId)

Delete an access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroupId = 789; // int | The access group to delete

try { 
    api_instance.deleteAccessgroup(accessGroupId);
} catch (e) {
    print("Exception when calling AccessGroupsApi->deleteAccessgroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroupId** | **int**| The access group to delete | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteUserOfAccessGroup**
> deleteUserOfAccessGroup(accessGroupId, userId)

Delete a user of an access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroupId = 789; // int | 
var userId = 789; // int | 

try { 
    api_instance.deleteUserOfAccessGroup(accessGroupId, userId);
} catch (e) {
    print("Exception when calling AccessGroupsApi->deleteUserOfAccessGroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroupId** | **int**|  | [default to null]
 **userId** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getAccessgroup**
> RQMAccessGroup getAccessgroup(accessGroupId)

Get a specific access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroupId = 789; // int | 

try { 
    var result = api_instance.getAccessgroup(accessGroupId);
    print(result);
} catch (e) {
    print("Exception when calling AccessGroupsApi->getAccessgroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroupId** | **int**|  | [default to null]

### Return type

[**RQMAccessGroup**](RQMAccessGroup.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getAccessgroups**
> List<RQMAccessGroup> getAccessgroups()

Get all access groups

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();

try { 
    var result = api_instance.getAccessgroups();
    print(result);
} catch (e) {
    print("Exception when calling AccessGroupsApi->getAccessgroups: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List<RQMAccessGroup>**](RQMAccessGroup.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getUsersOfAccessGroup**
> List<RQMUser> getUsersOfAccessGroup(accessGroupId)

Get all users of a given access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroupId = 789; // int | 

try { 
    var result = api_instance.getUsersOfAccessGroup(accessGroupId);
    print(result);
} catch (e) {
    print("Exception when calling AccessGroupsApi->getUsersOfAccessGroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroupId** | **int**|  | [default to null]

### Return type

[**List<RQMUser>**](RQMUser.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **patchAccessgroup**
> patchAccessgroup(accessGroup)

Update an access group

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = AccessGroupsApi();
var accessGroup = RQMAccessGroup(); // RQMAccessGroup | The access group to update

try { 
    api_instance.patchAccessgroup(accessGroup);
} catch (e) {
    print("Exception when calling AccessGroupsApi->patchAccessgroup: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessGroup** | [**RQMAccessGroup**](RQMAccessGroup.md)| The access group to update | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

