# openrqm.api.ElementsApi

## Load the API package
```dart
import 'package:openrqm/api.dart';
```

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteElement**](ElementsApi.md#deleteElement) | **DELETE** /element | Delete an element
[**getElementTypes**](ElementsApi.md#getElementTypes) | **GET** /elementTypes | Get all element types
[**getElements**](ElementsApi.md#getElements) | **GET** /elements | Get all elements
[**getIncomingLinksOfElement**](ElementsApi.md#getIncomingLinksOfElement) | **GET** /element/inlinks | Get all links of a given element
[**getOutgoingLinksOfElement**](ElementsApi.md#getOutgoingLinksOfElement) | **GET** /element/outlinks | Get all links of a given element
[**patchElement**](ElementsApi.md#patchElement) | **PATCH** /element | Update an element
[**postElement**](ElementsApi.md#postElement) | **POST** /element | Add an element


# **deleteElement**
> deleteElement(elementId)

Delete an element

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();
var elementId = 789; // int | The element to delete

try { 
    api_instance.deleteElement(elementId);
} catch (e) {
    print("Exception when calling ElementsApi->deleteElement: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **elementId** | **int**| The element to delete | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getElementTypes**
> List<RQMElementType> getElementTypes()

Get all element types

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();

try { 
    var result = api_instance.getElementTypes();
    print(result);
} catch (e) {
    print("Exception when calling ElementsApi->getElementTypes: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List<RQMElementType>**](RQMElementType.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getElements**
> List<RQMElement> getElements(documentId)

Get all elements

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();
var documentId = 789; // int | The document id for which the elements are fetched

try { 
    var result = api_instance.getElements(documentId);
    print(result);
} catch (e) {
    print("Exception when calling ElementsApi->getElements: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **documentId** | **int**| The document id for which the elements are fetched | [default to null]

### Return type

[**List<RQMElement>**](RQMElement.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getIncomingLinksOfElement**
> List<RQMLink> getIncomingLinksOfElement(elementId)

Get all links of a given element

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();
var elementId = 789; // int | The id of the element

try { 
    var result = api_instance.getIncomingLinksOfElement(elementId);
    print(result);
} catch (e) {
    print("Exception when calling ElementsApi->getIncomingLinksOfElement: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **elementId** | **int**| The id of the element | [default to null]

### Return type

[**List<RQMLink>**](RQMLink.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getOutgoingLinksOfElement**
> List<RQMLink> getOutgoingLinksOfElement(elementId)

Get all links of a given element

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();
var elementId = 789; // int | The id of the element

try { 
    var result = api_instance.getOutgoingLinksOfElement(elementId);
    print(result);
} catch (e) {
    print("Exception when calling ElementsApi->getOutgoingLinksOfElement: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **elementId** | **int**| The id of the element | [default to null]

### Return type

[**List<RQMLink>**](RQMLink.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **patchElement**
> patchElement(element)

Update an element

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();
var element = RQMElement(); // RQMElement | The element to update

try { 
    api_instance.patchElement(element);
} catch (e) {
    print("Exception when calling ElementsApi->patchElement: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **element** | [**RQMElement**](RQMElement.md)| The element to update | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **postElement**
> postElement(aboveRank, belowRank, element)

Add an element

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ElementsApi();
var aboveRank = aboveRank_example; // String | The rank of the element above, if no above element exists this shall be set to aaaaaaaaaaaaaaaaaaaa
var belowRank = belowRank_example; // String | The rank of the element below, if no below element exists this shall be set to an empty string
var element = RQMElement(); // RQMElement | The element to create, if the element should be created at the highest level, the parentElementId shall be null

try { 
    api_instance.postElement(aboveRank, belowRank, element);
} catch (e) {
    print("Exception when calling ElementsApi->postElement: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **aboveRank** | **String**| The rank of the element above, if no above element exists this shall be set to aaaaaaaaaaaaaaaaaaaa | [default to null]
 **belowRank** | **String**| The rank of the element below, if no below element exists this shall be set to an empty string | [default to null]
 **element** | [**RQMElement**](RQMElement.md)| The element to create, if the element should be created at the highest level, the parentElementId shall be null | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

