# openrqm.api.ImportApi

## Load the API package
```dart
import 'package:openrqm/api.dart';
```

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Method | HTTP request | Description
------------- | ------------- | -------------
[**importDocument**](ImportApi.md#importDocument) | **POST** /import | Post document for import


# **importDocument**
> importDocument(workspaceId, upfile)

Post document for import

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ImportApi();
var workspaceId = 789; // int | The workspace for the document
var upfile = BINARY_DATA_HERE; // MultipartFile | The file to upload.

try { 
    api_instance.importDocument(workspaceId, upfile);
} catch (e) {
    print("Exception when calling ImportApi->importDocument: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**| The workspace for the document | [default to null]
 **upfile** | **MultipartFile**| The file to upload. | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

