# openrqm.api.ThemesApi

## Load the API package
```dart
import 'package:openrqm/api.dart';
```

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createTheme**](ThemesApi.md#createTheme) | **POST** /theme | Create a new theme
[**getElementTypeColorsOfTheme**](ThemesApi.md#getElementTypeColorsOfTheme) | **GET** /theme/elementTypeColors | Get all element type colors of a theme
[**getTheme**](ThemesApi.md#getTheme) | **GET** /theme | Get a theme
[**getThemesOfDocument**](ThemesApi.md#getThemesOfDocument) | **GET** /document/themes | Get all themes of a document
[**updateTheme**](ThemesApi.md#updateTheme) | **PATCH** /theme | Update a theme


# **createTheme**
> createTheme(theme)

Create a new theme

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ThemesApi();
var theme = RQMTheme(); // RQMTheme | 

try { 
    api_instance.createTheme(theme);
} catch (e) {
    print("Exception when calling ThemesApi->createTheme: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **theme** | [**RQMTheme**](RQMTheme.md)|  | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getElementTypeColorsOfTheme**
> List<RQMElementTypeColor> getElementTypeColorsOfTheme(themeId)

Get all element type colors of a theme

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ThemesApi();
var themeId = 789; // int | 

try { 
    var result = api_instance.getElementTypeColorsOfTheme(themeId);
    print(result);
} catch (e) {
    print("Exception when calling ThemesApi->getElementTypeColorsOfTheme: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **themeId** | **int**|  | [default to null]

### Return type

[**List<RQMElementTypeColor>**](RQMElementTypeColor.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getTheme**
> RQMTheme getTheme(themeId)

Get a theme

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ThemesApi();
var themeId = 789; // int | The theme id

try { 
    var result = api_instance.getTheme(themeId);
    print(result);
} catch (e) {
    print("Exception when calling ThemesApi->getTheme: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **themeId** | **int**| The theme id | [default to null]

### Return type

[**RQMTheme**](RQMTheme.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getThemesOfDocument**
> List<RQMTheme> getThemesOfDocument(documentId)

Get all themes of a document

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ThemesApi();
var documentId = 789; // int | The document id to identify the correct themes

try { 
    var result = api_instance.getThemesOfDocument(documentId);
    print(result);
} catch (e) {
    print("Exception when calling ThemesApi->getThemesOfDocument: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **documentId** | **int**| The document id to identify the correct themes | [default to null]

### Return type

[**List<RQMTheme>**](RQMTheme.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updateTheme**
> updateTheme(theme)

Update a theme

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = ThemesApi();
var theme = RQMTheme(); // RQMTheme | 

try { 
    api_instance.updateTheme(theme);
} catch (e) {
    print("Exception when calling ThemesApi->updateTheme: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **theme** | [**RQMTheme**](RQMTheme.md)|  | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

