# openrqm.api.UserManagementApi

## Load the API package
```dart
import 'package:openrqm/api.dart';
```

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Method | HTTP request | Description
------------- | ------------- | -------------
[**changeUser**](UserManagementApi.md#changeUser) | **PATCH** /user/change | Change user
[**deleteUser**](UserManagementApi.md#deleteUser) | **DELETE** /user/delete | Delete user
[**getInfo**](UserManagementApi.md#getInfo) | **GET** /user/info | Get info of user
[**getUsers**](UserManagementApi.md#getUsers) | **GET** /user | Get all users
[**login**](UserManagementApi.md#login) | **GET** /user/login | Login
[**logout**](UserManagementApi.md#logout) | **GET** /user/logout | Logout
[**register**](UserManagementApi.md#register) | **POST** /user/register | Register


# **changeUser**
> changeUser(id, passwordHash, newPasswordHash, user)

Change user

### Example 
```dart
import 'package:openrqm/api.dart';

var api_instance = UserManagementApi();
var id = 789; // int | 
var passwordHash = passwordHash_example; // String | 
var newPasswordHash = newPasswordHash_example; // String | The SHA512 of the new password
var user = RQMUser(); // RQMUser | 

try { 
    api_instance.changeUser(id, passwordHash, newPasswordHash, user);
} catch (e) {
    print("Exception when calling UserManagementApi->changeUser: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]
 **passwordHash** | **String**|  | [default to null]
 **newPasswordHash** | **String**| The SHA512 of the new password | [default to null]
 **user** | [**RQMUser**](RQMUser.md)|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteUser**
> deleteUser(passwordHash, id)

Delete user

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = UserManagementApi();
var passwordHash = passwordHash_example; // String | 
var id = 789; // int | 

try { 
    api_instance.deleteUser(passwordHash, id);
} catch (e) {
    print("Exception when calling UserManagementApi->deleteUser: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **passwordHash** | **String**|  | [default to null]
 **id** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getInfo**
> RQMUser getInfo(id)

Get info of user

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = UserManagementApi();
var id = 789; // int | 

try { 
    var result = api_instance.getInfo(id);
    print(result);
} catch (e) {
    print("Exception when calling UserManagementApi->getInfo: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

[**RQMUser**](RQMUser.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getUsers**
> List<int> getUsers()

Get all users

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = UserManagementApi();

try { 
    var result = api_instance.getUsers();
    print(result);
} catch (e) {
    print("Exception when calling UserManagementApi->getUsers: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

**List<int>**

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **login**
> RQMToken login(passwordHash, email)

Login

### Example 
```dart
import 'package:openrqm/api.dart';

var api_instance = UserManagementApi();
var passwordHash = passwordHash_example; // String | 
var email = email_example; // String | 

try { 
    var result = api_instance.login(passwordHash, email);
    print(result);
} catch (e) {
    print("Exception when calling UserManagementApi->login: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **passwordHash** | **String**|  | [default to null]
 **email** | **String**|  | [default to null]

### Return type

[**RQMToken**](RQMToken.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **logout**
> logout(id)

Logout

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = UserManagementApi();
var id = 789; // int | 

try { 
    api_instance.logout(id);
} catch (e) {
    print("Exception when calling UserManagementApi->logout: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **register**
> RQMToken register(passwordHash, user)

Register

### Example 
```dart
import 'package:openrqm/api.dart';

var api_instance = UserManagementApi();
var passwordHash = passwordHash_example; // String | 
var user = RQMUser(); // RQMUser | 

try { 
    var result = api_instance.register(passwordHash, user);
    print(result);
} catch (e) {
    print("Exception when calling UserManagementApi->register: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **passwordHash** | **String**|  | [default to null]
 **user** | [**RQMUser**](RQMUser.md)|  | 

### Return type

[**RQMToken**](RQMToken.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

