# openrqm.api.WorkspacesApi

## Load the API package
```dart
import 'package:openrqm/api.dart';
```

All URIs are relative to *https://virtserver.swaggerhub.com/OpenRQM/OpenRQM/1.0.0*

Method | HTTP request | Description
------------- | ------------- | -------------
[**addAccessGroupToWorkspace**](WorkspacesApi.md#addAccessGroupToWorkspace) | **POST** /workspace/accessgroups | Add an access group to a workspace
[**addUserToWorkspace**](WorkspacesApi.md#addUserToWorkspace) | **POST** /workspace/users | Add a user to a workspace
[**deleteAccessGroupOfWorkspace**](WorkspacesApi.md#deleteAccessGroupOfWorkspace) | **DELETE** /workspace/accessgroups | Delete a workspace
[**deleteUserOfWorkspace**](WorkspacesApi.md#deleteUserOfWorkspace) | **DELETE** /workspace/users | Delete a user of a workspace
[**deleteWorkspace**](WorkspacesApi.md#deleteWorkspace) | **DELETE** /workspace | Delete a workspace
[**getAccessGroupsOfWorkspace**](WorkspacesApi.md#getAccessGroupsOfWorkspace) | **GET** /workspace/accessgroups | Get all access groups of a given workspace
[**getUsersOfWorkspace**](WorkspacesApi.md#getUsersOfWorkspace) | **GET** /workspace/users | Get all users of a given workspace
[**getWorkspace**](WorkspacesApi.md#getWorkspace) | **GET** /workspace | Get a workspace
[**getWorkspaces**](WorkspacesApi.md#getWorkspaces) | **GET** /workspaces | Get all workspaces
[**patchAccessGroupOfWorkspace**](WorkspacesApi.md#patchAccessGroupOfWorkspace) | **PATCH** /workspace/accessgroups | Update an access group of a workspace
[**patchUserOfWorkspace**](WorkspacesApi.md#patchUserOfWorkspace) | **PATCH** /workspace/users | Update a user of a workspace
[**patchWorkspace**](WorkspacesApi.md#patchWorkspace) | **PATCH** /workspace | Update a workspace
[**postWorkspace**](WorkspacesApi.md#postWorkspace) | **POST** /workspace | Add a workspace


# **addAccessGroupToWorkspace**
> addAccessGroupToWorkspace(workspaceId, accessGroup)

Add an access group to a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 
var accessGroup = RQMWorkspaceAccessgroup(); // RQMWorkspaceAccessgroup | 

try { 
    api_instance.addAccessGroupToWorkspace(workspaceId, accessGroup);
} catch (e) {
    print("Exception when calling WorkspacesApi->addAccessGroupToWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]
 **accessGroup** | [**RQMWorkspaceAccessgroup**](RQMWorkspaceAccessgroup.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **addUserToWorkspace**
> addUserToWorkspace(workspaceId, user)

Add a user to a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 
var user = RQMWorkspaceUser(); // RQMWorkspaceUser | 

try { 
    api_instance.addUserToWorkspace(workspaceId, user);
} catch (e) {
    print("Exception when calling WorkspacesApi->addUserToWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]
 **user** | [**RQMWorkspaceUser**](RQMWorkspaceUser.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteAccessGroupOfWorkspace**
> deleteAccessGroupOfWorkspace(workspaceId, accessGroupId)

Delete a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 
var accessGroupId = 789; // int | The access group to delete

try { 
    api_instance.deleteAccessGroupOfWorkspace(workspaceId, accessGroupId);
} catch (e) {
    print("Exception when calling WorkspacesApi->deleteAccessGroupOfWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]
 **accessGroupId** | **int**| The access group to delete | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteUserOfWorkspace**
> deleteUserOfWorkspace(workspaceId, userId)

Delete a user of a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 
var userId = 789; // int | 

try { 
    api_instance.deleteUserOfWorkspace(workspaceId, userId);
} catch (e) {
    print("Exception when calling WorkspacesApi->deleteUserOfWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]
 **userId** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteWorkspace**
> deleteWorkspace(workspaceId)

Delete a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | The workspace to delete

try { 
    api_instance.deleteWorkspace(workspaceId);
} catch (e) {
    print("Exception when calling WorkspacesApi->deleteWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**| The workspace to delete | [default to null]

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getAccessGroupsOfWorkspace**
> List<RQMWorkspaceAccessgroup> getAccessGroupsOfWorkspace(workspaceId)

Get all access groups of a given workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 

try { 
    var result = api_instance.getAccessGroupsOfWorkspace(workspaceId);
    print(result);
} catch (e) {
    print("Exception when calling WorkspacesApi->getAccessGroupsOfWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]

### Return type

[**List<RQMWorkspaceAccessgroup>**](RQMWorkspaceAccessgroup.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getUsersOfWorkspace**
> List<RQMWorkspaceUser> getUsersOfWorkspace(workspaceId)

Get all users of a given workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 

try { 
    var result = api_instance.getUsersOfWorkspace(workspaceId);
    print(result);
} catch (e) {
    print("Exception when calling WorkspacesApi->getUsersOfWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]

### Return type

[**List<RQMWorkspaceUser>**](RQMWorkspaceUser.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getWorkspace**
> RQMWorkspace getWorkspace(workspaceId)

Get a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | The workspace identifier

try { 
    var result = api_instance.getWorkspace(workspaceId);
    print(result);
} catch (e) {
    print("Exception when calling WorkspacesApi->getWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**| The workspace identifier | [default to null]

### Return type

[**RQMWorkspace**](RQMWorkspace.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getWorkspaces**
> List<RQMWorkspace> getWorkspaces()

Get all workspaces

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();

try { 
    var result = api_instance.getWorkspaces();
    print(result);
} catch (e) {
    print("Exception when calling WorkspacesApi->getWorkspaces: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List<RQMWorkspace>**](RQMWorkspace.md)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **patchAccessGroupOfWorkspace**
> patchAccessGroupOfWorkspace(workspaceId, accessGroup)

Update an access group of a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 
var accessGroup = RQMWorkspaceAccessgroup(); // RQMWorkspaceAccessgroup | 

try { 
    api_instance.patchAccessGroupOfWorkspace(workspaceId, accessGroup);
} catch (e) {
    print("Exception when calling WorkspacesApi->patchAccessGroupOfWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]
 **accessGroup** | [**RQMWorkspaceAccessgroup**](RQMWorkspaceAccessgroup.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **patchUserOfWorkspace**
> patchUserOfWorkspace(workspaceId, user)

Update a user of a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspaceId = 789; // int | 
var user = RQMWorkspaceUser(); // RQMWorkspaceUser | 

try { 
    api_instance.patchUserOfWorkspace(workspaceId, user);
} catch (e) {
    print("Exception when calling WorkspacesApi->patchUserOfWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspaceId** | **int**|  | [default to null]
 **user** | [**RQMWorkspaceUser**](RQMWorkspaceUser.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **patchWorkspace**
> patchWorkspace(workspace)

Update a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspace = RQMWorkspace(); // RQMWorkspace | The workspace to update

try { 
    api_instance.patchWorkspace(workspace);
} catch (e) {
    print("Exception when calling WorkspacesApi->patchWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspace** | [**RQMWorkspace**](RQMWorkspace.md)| The workspace to update | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **postWorkspace**
> postWorkspace(workspace)

Add a workspace

### Example 
```dart
import 'package:openrqm/api.dart';
// TODO Configure API key authorization: APIKeyHeader
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('APIKeyHeader').apiKeyPrefix = 'Bearer';

var api_instance = WorkspacesApi();
var workspace = RQMWorkspace(); // RQMWorkspace | The workspace to create

try { 
    api_instance.postWorkspace(workspace);
} catch (e) {
    print("Exception when calling WorkspacesApi->postWorkspace: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workspace** | [**RQMWorkspace**](RQMWorkspace.md)| The workspace to create | 

### Return type

void (empty response body)

### Authorization

[APIKeyHeader](../README.md#APIKeyHeader)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

