part of openrqm.api;



class AccessGroupsApi {
  final ApiClient apiClient;

  AccessGroupsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Add an access group with HTTP info returned
  ///
  /// 
  Future addAccessgroupWithHttpInfo(RQMAccessGroup accessGroup) async {
    Object postBody = accessGroup;

    // verify required params are set
    if(accessGroup == null) {
     throw ApiException(400, "Missing required param: accessGroup");
    }

    // create path and map variables
    String path = "/accessgroup".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Add an access group
  ///
  /// 
  Future addAccessgroup(RQMAccessGroup accessGroup) async {
    Response response = await addAccessgroupWithHttpInfo(accessGroup);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
    } else {
      return;
    }
  }

  /// Add a user to an access group with HTTP info returned
  ///
  /// 
  Future addUserToAccessGroupWithHttpInfo(int accessGroupId, int userId) async {
    Object postBody;

    // verify required params are set
    if(accessGroupId == null) {
     throw ApiException(400, "Missing required param: accessGroupId");
    }
    if(userId == null) {
     throw ApiException(400, "Missing required param: userId");
    }

    // create path and map variables
    String path = "/accessgroup/users".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "accessGroupId", accessGroupId));
      queryParams.addAll(_convertParametersForCollectionFormat("", "userId", userId));

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Add a user to an access group
  ///
  /// 
  Future addUserToAccessGroup(int accessGroupId, int userId) async {
    Response response = await addUserToAccessGroupWithHttpInfo(accessGroupId, userId);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
    } else {
      return;
    }
  }

  /// Delete an access group with HTTP info returned
  ///
  /// 
  Future deleteAccessgroupWithHttpInfo(int accessGroupId) async {
    Object postBody;

    // verify required params are set
    if(accessGroupId == null) {
     throw ApiException(400, "Missing required param: accessGroupId");
    }

    // create path and map variables
    String path = "/accessgroup".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "accessGroupId", accessGroupId));

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Delete an access group
  ///
  /// 
  Future deleteAccessgroup(int accessGroupId) async {
    Response response = await deleteAccessgroupWithHttpInfo(accessGroupId);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
    } else {
      return;
    }
  }

  /// Delete a user of an access group with HTTP info returned
  ///
  /// 
  Future deleteUserOfAccessGroupWithHttpInfo(int accessGroupId, int userId) async {
    Object postBody;

    // verify required params are set
    if(accessGroupId == null) {
     throw ApiException(400, "Missing required param: accessGroupId");
    }
    if(userId == null) {
     throw ApiException(400, "Missing required param: userId");
    }

    // create path and map variables
    String path = "/accessgroup/users".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "accessGroupId", accessGroupId));
      queryParams.addAll(_convertParametersForCollectionFormat("", "userId", userId));

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Delete a user of an access group
  ///
  /// 
  Future deleteUserOfAccessGroup(int accessGroupId, int userId) async {
    Response response = await deleteUserOfAccessGroupWithHttpInfo(accessGroupId, userId);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
    } else {
      return;
    }
  }

  /// Get a specific access group with HTTP info returned
  ///
  /// 
  Future<Response> getAccessgroupWithHttpInfo(int accessGroupId) async {
    Object postBody;

    // verify required params are set
    if(accessGroupId == null) {
     throw ApiException(400, "Missing required param: accessGroupId");
    }

    // create path and map variables
    String path = "/accessgroup".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "accessGroupId", accessGroupId));

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Get a specific access group
  ///
  /// 
  Future<RQMAccessGroup> getAccessgroup(int accessGroupId) async {
    Response response = await getAccessgroupWithHttpInfo(accessGroupId);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
      return apiClient.deserialize(_decodeBodyBytes(response), 'RQMAccessGroup') as RQMAccessGroup;
    } else {
      return null;
    }
  }

  /// Get all access groups with HTTP info returned
  ///
  /// 
  Future<Response> getAccessgroupsWithHttpInfo() async {
    Object postBody;

    // verify required params are set

    // create path and map variables
    String path = "/accessgroups".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Get all access groups
  ///
  /// 
  Future<List<RQMAccessGroup>> getAccessgroups() async {
    Response response = await getAccessgroupsWithHttpInfo();
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
      return (apiClient.deserialize(_decodeBodyBytes(response), 'List<RQMAccessGroup>') as List).map((item) => item as RQMAccessGroup).toList();
    } else {
      return null;
    }
  }

  /// Get all users of a given access group with HTTP info returned
  ///
  /// 
  Future<Response> getUsersOfAccessGroupWithHttpInfo(int accessGroupId) async {
    Object postBody;

    // verify required params are set
    if(accessGroupId == null) {
     throw ApiException(400, "Missing required param: accessGroupId");
    }

    // create path and map variables
    String path = "/accessgroup/users".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "accessGroupId", accessGroupId));

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Get all users of a given access group
  ///
  /// 
  Future<List<RQMUser>> getUsersOfAccessGroup(int accessGroupId) async {
    Response response = await getUsersOfAccessGroupWithHttpInfo(accessGroupId);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
      return (apiClient.deserialize(_decodeBodyBytes(response), 'List<RQMUser>') as List).map((item) => item as RQMUser).toList();
    } else {
      return null;
    }
  }

  /// Update an access group with HTTP info returned
  ///
  /// 
  Future patchAccessgroupWithHttpInfo(RQMAccessGroup accessGroup) async {
    Object postBody = accessGroup;

    // verify required params are set
    if(accessGroup == null) {
     throw ApiException(400, "Missing required param: accessGroup");
    }

    // create path and map variables
    String path = "/accessgroup".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};

    List<String> contentTypes = [];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'PATCH',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Update an access group
  ///
  /// 
  Future patchAccessgroup(RQMAccessGroup accessGroup) async {
    Response response = await patchAccessgroupWithHttpInfo(accessGroup);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
    } else {
      return;
    }
  }

}
