part of openrqm.api;



class ImportApi {
  final ApiClient apiClient;

  ImportApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Post document for import with HTTP info returned
  ///
  /// 
  Future importDocumentWithHttpInfo(int workspaceId, MultipartFile upfile) async {
    Object postBody;

    // verify required params are set
    if(workspaceId == null) {
     throw ApiException(400, "Missing required param: workspaceId");
    }
    if(upfile == null) {
     throw ApiException(400, "Missing required param: upfile");
    }

    // create path and map variables
    String path = "/import".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
      queryParams.addAll(_convertParametersForCollectionFormat("", "workspaceId", workspaceId));

    List<String> contentTypes = ["multipart/form-data"];

    String contentType = contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    List<String> authNames = ["APIKeyHeader"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = MultipartRequest(null, null);
      if (upfile != null) {
        hasFields = true;
        mp.fields['upfile'] = upfile.field;
        mp.files.add(upfile);
      }
      if(hasFields)
        postBody = mp;
    }
    else {
    }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);
    return response;
  }

  /// Post document for import
  ///
  /// 
  Future importDocument(int workspaceId, MultipartFile upfile) async {
    Response response = await importDocumentWithHttpInfo(workspaceId, upfile);
    if(response.statusCode >= 400) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    } else if(response.body != null) {
    } else {
      return;
    }
  }

}
