part of openrqm.api;

class RQMDocument {
  
  int id = null;
  
  int workspaceId = null;
  
  int internalIdentifier = null;
  
  String externalIdentifier = null;
  
  String name = null;
  
  String shortName = null;
  
  String description = null;
  
  String confidentiality = null;
  
  int authorId = null;
  
  int languageId = null;
  
  int approverId = null;
  
  String reviewerText = null;
  
  int lastModifiedById = null;
  
  DateTime lastModifiedOn = null;
  
  int baselineMajor = null;
  
  int baselineMinor = null;
  
  int baselineReview = null;
  
  int previousBaselineId = null;
  RQMDocument();

  @override
  String toString() {
    return 'RQMDocument[id=$id, workspaceId=$workspaceId, internalIdentifier=$internalIdentifier, externalIdentifier=$externalIdentifier, name=$name, shortName=$shortName, description=$description, confidentiality=$confidentiality, authorId=$authorId, languageId=$languageId, approverId=$approverId, reviewerText=$reviewerText, lastModifiedById=$lastModifiedById, lastModifiedOn=$lastModifiedOn, baselineMajor=$baselineMajor, baselineMinor=$baselineMinor, baselineReview=$baselineReview, previousBaselineId=$previousBaselineId, ]';
  }

  RQMDocument.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    id = json['id'];
    workspaceId = json['workspaceId'];
    internalIdentifier = json['internalIdentifier'];
    externalIdentifier = json['externalIdentifier'];
    name = json['name'];
    shortName = json['shortName'];
    description = json['description'];
    confidentiality = json['confidentiality'];
    authorId = json['authorId'];
    languageId = json['languageId'];
    approverId = json['approverId'];
    reviewerText = json['reviewerText'];
    lastModifiedById = json['lastModifiedById'];
    lastModifiedOn = (json['lastModifiedOn'] == null) ?
      null :
      DateTime.parse(json['lastModifiedOn']);
    baselineMajor = json['baselineMajor'];
    baselineMinor = json['baselineMinor'];
    baselineReview = json['baselineReview'];
    previousBaselineId = json['previousBaselineId'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (id != null)
      json['id'] = id;
    if (workspaceId != null)
      json['workspaceId'] = workspaceId;
    if (internalIdentifier != null)
      json['internalIdentifier'] = internalIdentifier;
    if (externalIdentifier != null)
      json['externalIdentifier'] = externalIdentifier;
    if (name != null)
      json['name'] = name;
    if (shortName != null)
      json['shortName'] = shortName;
    if (description != null)
      json['description'] = description;
    if (confidentiality != null)
      json['confidentiality'] = confidentiality;
    if (authorId != null)
      json['authorId'] = authorId;
    if (languageId != null)
      json['languageId'] = languageId;
    if (approverId != null)
      json['approverId'] = approverId;
    if (reviewerText != null)
      json['reviewerText'] = reviewerText;
    if (lastModifiedById != null)
      json['lastModifiedById'] = lastModifiedById;
    if (lastModifiedOn != null)
      json['lastModifiedOn'] = lastModifiedOn == null ? null : lastModifiedOn.toUtc().toIso8601String();
    if (baselineMajor != null)
      json['baselineMajor'] = baselineMajor;
    if (baselineMinor != null)
      json['baselineMinor'] = baselineMinor;
    if (baselineReview != null)
      json['baselineReview'] = baselineReview;
    if (previousBaselineId != null)
      json['previousBaselineId'] = previousBaselineId;
    return json;
  }

  static List<RQMDocument> listFromJson(List<dynamic> json) {
    return json == null ? List<RQMDocument>() : json.map((value) => RQMDocument.fromJson(value)).toList();
  }

  static Map<String, RQMDocument> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, RQMDocument>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = RQMDocument.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of RQMDocument-objects as value to a dart map
  static Map<String, List<RQMDocument>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<RQMDocument>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = RQMDocument.listFromJson(value);
       });
     }
     return map;
  }
}

