part of openrqm.api;

class RQMElement {
  /* When creating an element the id is ignored by the backend because it generates one, when updating the element it has to be set */
  int id = null;
  /* When creating an element the documentId has to be set to assign the requirement to the correct document, it can not be updated. */
  int documentId = null;
  
  int elementTypeId = null;
  
  String content = null;
  
  String rank = null;
  
  int parentElementId = null;
  RQMElement();

  @override
  String toString() {
    return 'RQMElement[id=$id, documentId=$documentId, elementTypeId=$elementTypeId, content=$content, rank=$rank, parentElementId=$parentElementId, ]';
  }

  RQMElement.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    id = json['id'];
    documentId = json['documentId'];
    elementTypeId = json['elementTypeId'];
    content = json['content'];
    rank = json['rank'];
    parentElementId = json['parentElementId'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (id != null)
      json['id'] = id;
    if (documentId != null)
      json['documentId'] = documentId;
    if (elementTypeId != null)
      json['elementTypeId'] = elementTypeId;
    if (content != null)
      json['content'] = content;
    if (rank != null)
      json['rank'] = rank;
    if (parentElementId != null)
      json['parentElementId'] = parentElementId;
    return json;
  }

  static List<RQMElement> listFromJson(List<dynamic> json) {
    return json == null ? List<RQMElement>() : json.map((value) => RQMElement.fromJson(value)).toList();
  }

  static Map<String, RQMElement> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, RQMElement>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = RQMElement.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of RQMElement-objects as value to a dart map
  static Map<String, List<RQMElement>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<RQMElement>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = RQMElement.listFromJson(value);
       });
     }
     return map;
  }
}

