part of openrqm.api;

class RQMLink {
  /* Id of the link */
  int id = null;
  
  int fromElementId = null;
  
  int fromDocumentId = null;
  
  String fromDocumentShortName = null;
  
  int toElementId = null;
  
  int toDocumentId = null;
  
  String toDocumentShortName = null;
  
  int linkTypeId = null;
  RQMLink();

  @override
  String toString() {
    return 'RQMLink[id=$id, fromElementId=$fromElementId, fromDocumentId=$fromDocumentId, fromDocumentShortName=$fromDocumentShortName, toElementId=$toElementId, toDocumentId=$toDocumentId, toDocumentShortName=$toDocumentShortName, linkTypeId=$linkTypeId, ]';
  }

  RQMLink.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    id = json['id'];
    fromElementId = json['fromElementId'];
    fromDocumentId = json['fromDocumentId'];
    fromDocumentShortName = json['fromDocumentShortName'];
    toElementId = json['toElementId'];
    toDocumentId = json['toDocumentId'];
    toDocumentShortName = json['toDocumentShortName'];
    linkTypeId = json['linkTypeId'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (id != null)
      json['id'] = id;
    if (fromElementId != null)
      json['fromElementId'] = fromElementId;
    if (fromDocumentId != null)
      json['fromDocumentId'] = fromDocumentId;
    if (fromDocumentShortName != null)
      json['fromDocumentShortName'] = fromDocumentShortName;
    if (toElementId != null)
      json['toElementId'] = toElementId;
    if (toDocumentId != null)
      json['toDocumentId'] = toDocumentId;
    if (toDocumentShortName != null)
      json['toDocumentShortName'] = toDocumentShortName;
    if (linkTypeId != null)
      json['linkTypeId'] = linkTypeId;
    return json;
  }

  static List<RQMLink> listFromJson(List<dynamic> json) {
    return json == null ? List<RQMLink>() : json.map((value) => RQMLink.fromJson(value)).toList();
  }

  static Map<String, RQMLink> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, RQMLink>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = RQMLink.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of RQMLink-objects as value to a dart map
  static Map<String, List<RQMLink>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<RQMLink>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = RQMLink.listFromJson(value);
       });
     }
     return map;
  }
}

